const github = require('gh-got');
const npmPublishProgrammatically = require('npm-publish-programmatically');
const mapValues = require('lodash.mapvalues');
const log = require('./logger');
const chalk = require('chalk');
const clipboard = require('clipboardy');
const inferPackage = require('./package');

function publish(gistId, {npmToken}) {return __async(function*(){
	log.start(`${chalk.grey('fetching')} ${chalk.cyan.italic(`gist.github.com/${gistId}`)}`);
	const {body: {files, owner, history, description}} = yield github(`gists/${gistId}`);

	const pack = yield inferPackage({gistId, description, files, owner, history});
	const spec = `${pack.name}@${pack.version}`;

	log.message(`${chalk.grey('about to publish')} ${spec}`);

	const content = Object.assign(
		mapValues(files, ({content}) => content),
		{'package.json': pack}
	);

	yield npmPublishProgrammatically(content, {auth: npmToken});

	log.success(`${chalk.grey('published')} ${spec}`);

	try {
		yield clipboard.write(spec);
		log.clipboard('copied to clipboard');
	} catch(e) {}
}())}

module.exports = publish;

function __async(g){return new Promise(function(s,j){function c(a,x){try{var r=g[x?"throw":"next"](a)}catch(e){j(e);return}r.done?s(r.value):Promise.resolve(r.value).then(c,d)}function d(e){c(e,1)}c()})}
